!- TRIANGULAR μOS 1.25/C64 for Commodore 64
!- UOS


!- Program listing obfuscated
0 goto1:rem"{20*12}  ***** triangular{cm m}{cm x}os 1.25/c64 *****   "{204}

!- Set BASIC variables & launch hardware tests & set memory variables :: set poke809 to 255/246 for disable/enable Run/Stop
1print"{clear}{ct h}{cyan}{142}":clr:poke809,255:poke53280,.:poke53281,.:q$=chr$(34):v$="1.25/c64":pa=65532:gosub98:gosub9:if(fre(x)+65535)<34200thenn$="not enough ram!":goto23
2gosub21:gosub25:fm=64:gosub9:gosub10:dd=1:poke998,fm:poke989,dd:poke990,.:poke995,158:poke994,31:poke996,.:poke997,230:poke991,1:poke992,10:poke993,20:bs=peek(960):ifbs<8andbs>11thenbs=8

!- Launch screen
3bi=.:print"{clear}";:gosub9:print"{down*2}{purple}{cm @*40}";:gosub56:printtab(13)"{up}{cm asterisk}{reverse on}            {reverse off}{sh pound}":gosub57:printtab(15)"{up}{cm asterisk}{reverse on}        {reverse off}{sh pound}":gosub57:printtab(17)"{up}{cm asterisk}{reverse on}    {reverse off}{sh pound}":gosub57:printtab(19)"{up}{cm asterisk}{sh pound}":gosub57
4print"{down}{blue}  {cm c}{reverse on}{cm d}{cm k}{reverse off}{cm b}{reverse on}{cm k}{reverse off}{cm d}{cm b}{reverse on}{cm k}{reverse off}{cm f}{cm k}{reverse on}{cm b}{reverse off}{cm v}{cm k*3} {reverse on}{cm b}{reverse off}{cm f}{reverse on}{cm d}{reverse off}{cm f}   {light blue}{reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm v} {light gray}(c) 2022{return}{blue}   {cm k}{reverse on}{cm k}{reverse off}{cm b}{reverse on}{cm k*2}{cm f}{cm k}{reverse off}{cm c}{cm k*6} {reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm f} {red}{cm k*2}{light blue}{cm k*2}{reverse on}{cm i}{reverse off}{cm k}{return}{blue}   {cm v}{cm c*6} {cm v}{cm c}{cm v}{reverse on}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v*5} {reverse on}{red}{cm i}{reverse off}{cm k}{reverse on}{light blue}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v}{cyan} "v$
5gosub9:ifrn=.then76
6printtab(26)"{down*4}{reverse on}{yellow}f1{reverse off} {green}bios setup";:poke198,.:gosub12
7getk$:ifk$="{f1}"then27

!- Load GUI
8n$="gui":l$=" loading...":print"{purple}";:gosub94:goto95

!- Delay 500 for's
9forj=.to500:nextj:return

!- Beep sound
10poke54296,15:poke54277,0:poke54278,248:poke54276,17:poke54272,.:poke54273,37:forj=.to120:nextj:poke54273,.:forj=.to100:nextj:return

!- Beep sound x3
11gosub10:gosub10:gosub10:return

!- Delay 2000 for's
12fori=.to2000:nexti:return

!- Disk dirve tests (drive # evaluatian: 8+di)
13open1,8+di,2:close1:ifst<>.then17
14gosub20:ifer$=""then17
15open1,8+di,15:print#1,"m-r";chr$(51);chr$(255):get#1,d$:t1=asc(d$+chr$(.)):close1:vt$="":open5,8+di,5,"uos>cfg,s,r":input#5,vt$:close5:gosub20:poke971+di,1:poke975+di,t1:bi=1:ifv$=vt$then18
16return
17poke971+di,.:poke975+di,.:return

18bd=8+di:ifbs=bdthent=1
19return

!- Read disk error channel
20open1,8+di,15:input#1,en,er$,tr,sc:close1:return

!- Commodore 64 type confirmation
21poke198,.:poke631,167:poke632,189:poke198,2:getk$:geta$:k$=k$+a$:ifk$="{cm m}{cm x}"andpeek(pa)=226andpeek(pa+1)=252then24
22n$="can't run this{cm m}{cm x}os version!"

!- Shut down with error message
23l$="shut down...":print"{red}";:gosub94:print"{home}{red}"n$:gosub9:gosub11:gosub12:sys64738

!- Set up initial memory variables
24poke1000,peek(53296)and5:restore:fori=.to5:readj:poke980+i,j:nexti:return:data19,13,82,85,78,13

!- Cursor test & screen mode detection
25print"{clear}{down}{cm p}";:gosub9:ifpeek(((peek(648))*256)+40)=111thenpoke999,40:return
26print"{clear}":gosub9:n$="this graphic mode is not supported!":goto23

!- BIOS Setup menu
27print"{clear}{down}{purple} {cm asterisk}{reverse on}  {reverse off}{sh pound}{cyan} triangular bios "v$"{return}  {purple}{cm asterisk}{sh pound}{cyan}  (c) 2022{down*2}{return}  {blue}commodore{red}"64-64*(peek(1000)-5)"{cyan}  ram:"fm"{left}kb{down}{return}   #: device:         boot/work":cs$="none":ifcs=1thencs$="cbm datasette":
28db=dd:wb=wd:bb=bd:print"   {reverse on}{red}1{cyan}{reverse off}: ":gosub84:fori=.to3
29gosub64:print"  "8+i;"{left}:",:ifdi(i)=.thenprint"{left*7}none"
30ifdi(i)=1thenprint"{left*4}cbm "dt$(i)"{return}","{up}{right*13}{reverse on}{yellow}"(i*2)+1"{left*3}f{right*3}{green}"(i*2)+2"{left*3}f{reverse off}{cyan}"
31nexti:print"{down}   boot:     work:{return}{down*2}  {reverse on}{red}t{cyan}{reverse off}ime:{return}{down}  {reverse on}{red}r{cyan}{reverse off}eset clock{return}{down*2}  {reverse on}{red}e{cyan}{reverse off}xit {reverse on}{red}s{cyan}{reverse off}ave {reverse on}{red}b{cyan}{reverse off}asic":poke198,.
32gosub58:gosub63:getk$:ifk$=""then32
33ifk$="e"thenprint"{clear}":dd=db:wd=wb:bd=bb:goto3
34ifk$="r"thenti$="000000"
35ifk$="1"thengosub87:gosub84
36ifk$="{f1}"theni=.:gosub59
37ifk$="{f2}"theni=.:gosub61
38ifk$="{f3}"theni=1:gosub59
39ifk$="{f4}"theni=1:gosub61
40ifk$="{f5}"theni=2:gosub59
41ifk$="{f6}"theni=2:gosub61
42ifk$="{f7}"theni=3:gosub59
43ifk$="{f8}"theni=3:gosub61
44ifk$="t"thengosub50
45ifk$="s"then48
46ifk$="b"then97
47goto32

48open1,bd,15,"r0:uos=uos":close1:gosub83:ifer<>63thengosub10:gosub10:goto32
49gosub82:goto96

!- Time change
50gosub99:print"{white} {arrow left} {cyan}type new time":ks$="":kv$="":poke198,.:fori=.to5
51gosub58:gosub63:print"{down}{right*8}{light blue}"kv$"{cyan}":getk$:ifk$=""then51
52as=asc(k$):ifas>47andas<58thenks$=ks$+k$:goto54
53goto51

!- Time change display
54kv$=kv$+k$:ifi=1ori=3thenkv$=kv$+":"
55nexti:gosub99::print"                 ":ti$=ks$:poke198,.:return

!- Draw horizontal line 1
56print"{sh asterisk*40}":return

!- Draw horizontal line 2
57print"{cm t*40}":return

!- Time update > setup
58t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):print"{home}{down*17}{right*8}"t1$":"t2$":"t3$:return

!- Set Boot drive
59ifpeek(971+i)=1thenbd=8+i:return
60return

!- Set Work drive
61ifpeek(971+i)=1thenwd=8+i:return
62return

!- Boot & Work disk drive update > setup
63print"{home}{down*14}{right*8}{yellow}"bd"{left} ","{left*2}{green}"wd"{left} {cyan}":return

!- Disk drive database
64di(i)=peek(971+i):dn(i)=peek(975+i):dt$(i)="{left*4}unknown":ifdi(i)=.thenreturn
65ifdn(i)=16thendt$(i)="2040"
66ifdn(i)=76thendt$(i)="1541-ii"
67ifdn(i)=170thendt$(i)="1541"
68ifdn(i)=173thendt$(i)="1571"
69ifdn(i)=108thendt$(i)="1581"
70ifdn(i)=7thendt$(i)="2031"
71ifdn(i)=32thendt$(i)="3040"
72ifdn(i)=169thendt$(i)="4040"
73ifdn(i)=255thendt$(i)="1551"
74ifdn(i)=48thendt$(i)="{left*4}sd2iec"
75return

!- Check disk drives
76t=.:fordi=3to.step-1:gosub13:nextdi:ift=1thenbd=bs
77wd=bd:poke960,bd:poke961,wd:ifbi=.thenee$="   {reverse on}no disk drive!{reverse off}":goto90
78ifbd=.thenee$="   {reverse on}no system disk!{reverse off}":goto90

!- Load uos>cfg
79rn=1:open8,bd,8,"uos>cfg,s,r":close8:gosub83:poke991,1:ifer<>.then90
80open8,bd,8,"uos>cfg,s,r":input#8,v1$,wd$,dd$,gc$,gr$,cg$,tc$,pp$:close8:gosub83:poke997,val(gr$):poke996,val(gc$):poke994,val(cg$):wd=val(wd$):dd=val(dd$):poke989,dd:ifpeek(963+wd)=.thenwd=bd
81poke961,wd:poke995,val(tc$):poke990,val(pp$):goto6

!- Save uos>cfg
82open1,bd,15,"s0:uos>cfg":close1:open8,bd,8,"uos>cfg,w,s":print#8,v$:print#8,wd:print#8,dd:print#8,peek(996):print#8,peek(997):print#8,peek(994)::print#8,peek(995):print#8,peek(990):close8:poke989,dd:poke960,bd:poke961,wd:gosub83:return

!- Read disk error chanell
83open1,bd,15:input#1,er,er$,tr,sc:close1:return

!- Update Datasette status graphic > setup
84ifdd=.thenprint"{home}{down*8}{right*6}none         ":return
85ifdd=1thenprint"{home}{down*8}{right*6}cbm datasette":return
86return

!- Datasette enable On/Off
87ifdd=.thendd=1:return
88ifdd=1thendd=.:return
89return

!- Disk drive error
90printtab(9)"{down*2}{red}"ee$"{return}{down}{yellow} {reverse on}f1{green}{reverse off} retry"tab(31)"{red}{reverse on}f8{green}{reverse off} basic";:poke198,.:gosub11
91getk$:ifk$="{f1}"thenrn=.:print"{up*3}{black}";:fori=.to2:print"{space*38}":nexti:print"{delete*2}{up*5}":goto5
92ifk$="{f8}"then97
93goto91

!- Draw load
94print"{clear}{down*15}"tab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}{return}"tab(18)"{cm asterisk}{reverse on}  {reverse off}{sh pound}{return}"tab(19)"{cm asterisk}{sh pound}{return}{down}{white}"tab(12)"{cm @*16}{return}{white}"tab(11)"{cm m}{reverse on}{blue}{cm m*9}{reverse off}       {white}{cm g}{return}{white}"tab(12)"{cm t*16}{return}{white}{down}"tab(9)"     "l$:return

!- Load sequence
95print"{home}{black}load "q$n$q$","bd:poke198,.:fori=.to5:g=peek(980+i):poke631+i,g:nexti:poke198,6:new

!- Restaring
96l$="restarting...":print"{yellow}";:gosub94:n$="uos":goto95

!- Shut down
97l$="shut down...":print"{red}";:gosub94:gosub12:sys64738

!- Clear SID
98fori=54272to54296:pokei,.:nexti:return

!- Clear Time changer
99gosub63:print"{down}{right*8}       ";:return
